/**
 ** forceCntrlTaskCodels.c
 **
 ** Codels used by the control task forceCntrlTask
 **
 ** Author: Daniel Sidobre
 ** Date: 20 juillet 2006
 **
 **/

#ifdef VXWORKS
# include <vxWorks.h>
#else
# include <portLib.h>
#endif
#include "server/forceHeader.h"

#include "jr3Struct.h"
#include "forceFunctionHeader.h"
/*------------------------------------------------------------------------
 * forceInitNumberFFTCntrl  -  control codel of CONTROL request InitNumberFFT
 *
 * Description:    
 * Report: OK
 *                 S_force_FFTInitFailed
 *                 S_force_NotAPowerOfTwo
 *
 * Returns:    OK or ERROR
 */

STATUS
forceInitNumberFFTCntrl(int *numberFFT, int *report)
{
  int test = 0;
  int i;

 //  for (i = 4; i < 15; i++) {
 //    if (*numberFFT == (1 << i) ) test++;
 //  }
 //  if (test != 1) { /* must be a power of two */
 //    *report = S_force_NotAPowerOfTwo;
 //    return ERROR;
 //  }
 //  /* ??? bloquer les calculs */
 //
  if (forceFftInit(*numberFFT) != OK) {
    /* ??? */
    SDI_F->state.numberFFT = 0;
    *report = S_force_FFTInitFailed;
    return ERROR;
  }
  SDI_F->state.numberFFT = *numberFFT;
  return OK;
}

/*------------------------------------------------------------------------
 * forceInitFftDirectionCntrl  -  control codel of CONTROL request InitFftDirection
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
forceInitFftDirectionCntrl(Gb_force *fftDirection, int *report)
{
  /* Nothing to done : no constraint ... */
  return OK;
}

/*------------------------------------------------------------------------
 * forceFilterSetCntrl  -  control codel of CONTROL request FilterSet
 *
 * Description:    
 * Report: OK
 *                 S_force_NotAValidFilter
 *
 * Returns:    OK or ERROR
 */

STATUS
forceFilterSetCntrl(int *filter, int *report)
{
  if (*filter < 0 || *filter > 6) {
    *report = S_force_NotAValidFilter;
    return ERROR;
  }
  return OK;
}

/*------------------------------------------------------------------------
 * forceOffsetResetCntrl  -  control codel of CONTROL request OffsetReset
 *
 * Description:    
 * Report: OK
 *                 S_force_NotInitialized
 *
 * Returns:    OK or ERROR
 */

STATUS
forceOffsetResetCntrl(int *report)
{
  extern void forceOffsetReset(void);

  if (SDI_F->state.moduleInitialized == 0) {
    *report = S_force_NotInitialized;
    return ERROR;
  }
  forceOffsetReset();
  return OK;
}

/*------------------------------------------------------------------------
 * forceDetectCntrl  -  control codel of EXEC request Detect
 *
 * Description:    
 * Report: OK
 *                 S_force_NotInitialized
 *
 * Returns:    OK or ERROR
 */

STATUS
forceDetectCntrl(int *report)
{
  if (SDI_F->state.moduleInitialized == 0) {
    *report = S_force_NotInitialized;
    return ERROR;
  }
  return OK;
}

/*------------------------------------------------------------------------
 * forceDetectSet_nb_val_fftCntrl  -  control codel of CONTROL request DetectSet_nb_val_fft
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
forceDetectSet_nb_val_fftCntrl(int *nb_val_fft, int *report)
{
  return OK;
}

/*------------------------------------------------------------------------
 * forceDetectSetThresholdCntrl  -  control codel of CONTROL request DetectSetThreshold
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
forceDetectSetThresholdCntrl(double *threshold, int *report)
{
  return OK;
}

/*------------------------------------------------------------------------
 * forceMonitorForcesCntrl  -  control codel of EXEC request MonitorForces
 *
 * Description:    
 * Report: OK
 *                 S_force_NotInitialized
 *
 * Returns:    OK or ERROR
 */

STATUS
forceMonitorForcesCntrl(FORCE_MONITOR_DATA_STR *eq, int *report)
{
  if (SDI_F->state.moduleInitialized == 0) {
    *report = S_force_NotInitialized;
    return ERROR;
  }
  return OK;
}

/*------------------------------------------------------------------------
 * forceRecordForcesCntrl  -  control codel of CONTROL request RecordForces
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
forceRecordForcesCntrl(int *report)
{
  SDI_F->record_i = 0;

  return OK;
}


